//
//  CoinsCenterViewController.m
//  Open
//
//  Created by 雷俊博 on 2019/8/6.
//  Copyright © 2019 黄江涛 . All rights reserved.
//

#import "CoinsCenterViewController.h"
#import "UIColor+Hex.h"
#import "UIButton+ImageTitleSpacing.h"
#import <UICountingLabel.h>

#import "Constants.h"
#import "ExchangeMoneyBtn.h"

#import "SignInSuccessView.h"
#import "RetroactiveView.h"
#import "RedPackageSuccessView.h"

#import "SignInCollectionViewCell.h"
#import "LineCollectionReusableView.h"

#import "CoinCenterTableViewCell.h"

#import "WebVC.h"
#import "CTAPIBaseManager.h"

#import "CoinsDetailListVC.h"


//签到弹框
#import "SignInSuccessView.h"
//公众号弹框
#import "OfficialAccountsAlertView.h"
//弹框动画
#import <ZJAnimationPopView.h>
#import <Toast.h>


@interface CoinsCenterViewController ()<UITableViewDelegate,UITableViewDataSource,UICollectionViewDelegate,UICollectionViewDataSource>
{
    id _customView;
    
}


//导航栏
@property (nonatomic, strong)UIButton *rightBtn;

@property (nonatomic, strong)UIView *headerView;

@property (nonatomic, strong)UIView *cardView;

//card view
@property (nonatomic, strong)UICountingLabel *lb_coinsNum;

@property (nonatomic, strong)UILabel *lb_coinsNumTitle;

@property (nonatomic, strong)ExchangeMoneyBtn *btn_exchangeMoney;

@property (nonatomic, strong) UILabel *lb_allCoinsNumber;
@property (nonatomic, strong) UILabel *lb_mycoin;
@property (nonatomic, strong) UIView *divideLine;

@property (nonatomic, strong) UILabel *lb_todayCoinsNumber;
@property (nonatomic, strong) UILabel *lb_todayCoin;


@property (nonatomic, strong)UICollectionView *collectionView;

@property (nonatomic, strong)UIButton *btn_signIn;

@property (nonatomic, strong)UITableView *tableView;

@property (nonatomic, strong)NSMutableArray *dateArray;

@property (nonatomic, strong)NSMutableArray *dataArray;

@property (nonatomic, assign)NSInteger weekIndex;

@property (nonatomic, assign)BOOL isrefresh;



@end

@implementation CoinsCenterViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.view.backgroundColor = [UIColor whiteColor];
    
    [self.view addSubview:self.tableView];
    
    [self refreshHeaderViewData];
    
    
    
    
    [self loadData];
    
    self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc]initWithCustomView:self.rightBtn];
}
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.navigationController.navigationBar.barTintColor = [UIColor colorWithHex:0xed8b0b];
    
    [self.transitionCoordinator animateAlongsideTransition:^(id<UIViewControllerTransitionCoordinatorContext>  _Nonnull context) {
        self.navigationController.navigationBar.barTintColor = [UIColor colorWithHex:0xed8b0b];
         [self.navigationController.navigationBar setBackgroundImage:[UIImage  imageNamed:@""] forBarMetrics:UIBarMetricsDefault];
    } completion:^(id<UIViewControllerTransitionCoordinatorContext>  _Nonnull context) {
    }];
    
    
    NSString *pushStr = [[NSUserDefaults standardUserDefaults]objectForKey:@"pushKey"];
    if ([pushStr isEqualToString:@"unOpenPush"] && [self isUserNotificationEnable]) {
         [self increaseScoreWithType:@"1006"];
    }
    
    if (self.isrefresh) {
        [self refreshCoins];
    }
    
    
    
    
    
    
}

-(void)viewDidAppear:(BOOL)animated{
    [super viewDidAppear:animated];
    [JANALYTICSService startLogPageView:@"金币中心"];
    [MobClick beginLogPageView:@"金币中心"];
}
-(void)viewDidDisappear:(BOOL)animated{
    
    [super viewDidDisappear:animated];
    [JANALYTICSService stopLogPageView:@"金币中心"];
    [MobClick endLogPageView:@"金币中心"];
    
}


- (void)viewWillLayoutSubviews
{
    [super viewWillLayoutSubviews];
    [self.lb_coinsNum mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.top.offset(25 * WIDTHRADIU);
        make.centerX.equalTo(self.cardView);
        make.height.offset(25 * WIDTHRADIU);
    }];
    [self.lb_coinsNumTitle mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.lb_coinsNum.mas_bottom).offset(10 * WIDTHRADIU);
        make.centerX.equalTo(self.cardView);
        make.height.offset(13 * WIDTHRADIU);
    }];
    
    [self.btn_exchangeMoney mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.offset(38 * WIDTHRADIU);
        make.right.offset(0);
        make.width.offset(80 * WIDTHRADIU);
        make.height.offset(30 * WIDTHRADIU);
    }];
    
    [self.lb_allCoinsNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.cardView.mas_centerX).multipliedBy(0.5);
        make.top.equalTo(self.lb_coinsNumTitle.mas_bottom).offset(20 * WIDTHRADIU);
        make.height.offset(15 * WIDTHRADIU);
    }];
    [self.lb_mycoin mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.lb_allCoinsNumber);
        make.top.equalTo(self.lb_allCoinsNumber.mas_bottom).offset(10 * WIDTHRADIU);
        make.height.offset(13 * WIDTHRADIU);
    }];
    
    [self.divideLine mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.cardView);
        make.centerY.equalTo(self.lb_allCoinsNumber.mas_bottom).offset(4 * WIDTHRADIU);
        make.height.offset(35 * WIDTHRADIU);
        make.width.offset(0.5);
    }];
    [self.lb_todayCoinsNumber mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.cardView.mas_centerX).multipliedBy(1.5);
        make.centerY.equalTo(self.lb_allCoinsNumber);
        make.height.offset(15 * WIDTHRADIU);
    }];
    [self.lb_todayCoin mas_makeConstraints:^(MASConstraintMaker *make) {
        make.centerX.equalTo(self.lb_todayCoinsNumber);
        make.centerY.equalTo(self.lb_mycoin);
        make.height.offset(13 * WIDTHRADIU);
    }];
}



#pragma mark - loadData
- (void)refreshCoins
{
    if ([getPeopleID PeopleID] && [getPeopleID PeopleIphoneNmber])
    {
        NSDictionary *params = @{
                                 @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                                 @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY]
                                 };
        NSString *url =[NSString stringWithFormat:@"%@score/getpersonintegrals",CoinsBaseUrl];
        WeakSelf
        [BaseNetManager POST2:url parameters:params completionHandler:^(id responseObj, NSError *error) {
            
            weakSelf.isrefresh = YES;
           
            if (responseObj) {
                NSString *code = [responseObj[@"code"] stringValue];
                if ([code isEqualToString:@"0"]) {
                    [getPeopleID getTotalCoins:responseObj[@"result"]];
                    NSDictionary *dic = [getPeopleID totalCoins];
                    NSNumber *num = dic[@"totalScore"];
                    [weakSelf.lb_coinsNum countFrom:self.lb_coinsNum.text.integerValue  to:num.integerValue];
                    weakSelf.lb_todayCoinsNumber.text = [NSString stringWithFormat:@"%@",[dic[@"todaySore"] stringValue]];
                }
            }
            
        }];
    }
}

- (void)loadData
{
    
    
    [SVProgressHUD shows];
    NSString *url = [NSString stringWithFormat:@"%@/score/getuserTaskStatus",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                             @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                             @"telephone":[EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                             @"fromModel":@"2"
                             };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&Kanwf574",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        
       
            [SVProgressHUD doneShow];
            [SVProgressHUD dismiss];
        
       
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            if (code.integerValue == 0) {
                
                
                self.tableView.hidden = NO;
                self.dateArray = [[NSMutableArray alloc]initWithArray:responseObject[@"result"][@"dateTaskStatus"]];
                self.dataArray = [[NSMutableArray alloc]initWithArray:responseObject[@"result"][@"taskstatus"]];
                
                //获取今天是周几
                
                NSNumber *index = responseObject[@"result"][@"currentDayofWeek"];
                self.weekIndex = index.integerValue - 1;
                
                if (self.dateArray.count == 7) {
                    NSDictionary *dic = self.dateArray[self.weekIndex];
                    NSNumber *status = dic[@"status"];
                    if (status.integerValue == 302) {
                        [self setSignBtnInterace:NO];
                    }else if(status.integerValue == 303){
                        [self setSignBtnInterace:YES];
                    }
                }
                
                
               
                
                [self.collectionView reloadData];
                [self.tableView reloadData];
                
                
                
                [self refreshCoins];
                return ;
            }
        }
        
       
        
        
        
    }];
}

- (void)setSignBtnInterace:(BOOL)Interace
{
    if (Interace) {
        [_btn_signIn setTitle:@"签到" forState:UIControlStateNormal];
        [_btn_signIn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _btn_signIn.titleLabel.font = [UIFont systemFontOfSize:17 * WIDTHRADIU];
        _btn_signIn.backgroundColor = [UIColor colorWithHex:0xed8b0b];
        _btn_signIn.layer.cornerRadius = 22 * WIDTHRADIU;
        _btn_signIn.userInteractionEnabled = YES;
    }else{
        [_btn_signIn setTitle:@"今日已签到" forState:UIControlStateNormal];
        [_btn_signIn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _btn_signIn.titleLabel.font = [UIFont systemFontOfSize:17 * WIDTHRADIU];
        _btn_signIn.backgroundColor = [UIColor colorWithHex:0xffd28e];
        _btn_signIn.layer.cornerRadius = 22 * WIDTHRADIU;
        _btn_signIn.userInteractionEnabled = NO;
    }
}

- (void)refreshHeaderViewData
{

    NSDictionary *dic = [getPeopleID totalCoins];
    self.lb_coinsNum.text =  [NSString stringWithFormat:@"%@",[dic[@"totalScore"] stringValue]];
    self.lb_todayCoinsNumber.text = [NSString stringWithFormat:@"%@",[dic[@"todaySore"] stringValue]];
    
}


//签到请求
- (void)loadHttpData:(NSString *)str
{
    
     dispatch_group_t group = dispatch_group_create();
    
     dispatch_queue_t searialQueue = dispatch_queue_create("com.hmc.www", DISPATCH_QUEUE_SERIAL);
    
     dispatch_group_enter(group);
    dispatch_group_async(group, searialQueue, ^{
        //网络请求1
        if ([getPeopleID PeopleID] && [getPeopleID PeopleIphoneNmber])
        {
            NSDictionary *params = @{
                                     @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                                     @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY]
                                     };
            NSString *url =[NSString stringWithFormat:@"%@score/getpersonintegrals",CoinsBaseUrl];
            [BaseNetManager POST2:url parameters:params completionHandler:^(id responseObj, NSError *error) {
                dispatch_group_leave(group);
                if (responseObj) {
                    NSString *code = [responseObj[@"code"] stringValue];
                    if ([code isEqualToString:@"0"]) {
                        [getPeopleID getTotalCoins:responseObj[@"result"]];
                        
                    }
                }
                
            }];
        }
    });
    dispatch_group_enter(group);
    dispatch_group_async(group, searialQueue, ^{
        //网络请求2
        NSString *url = [NSString stringWithFormat:@"%@/score/getuserTaskStatus",CoinsBaseUrl];
        
        NSDictionary *dic = @{
                              @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                              @"telephone":[EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                              @"fromModel":@"2"
                              };
        
        
        NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
            
            NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
            
            return [obj1 compare:obj2]; //升序
            
        }];
        NSString *sign = nil;
        for (int i = 0; i < result.count; i++) {
            NSString *key = result[i];
            if (i==0) {
                sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
            }else{
                
                sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
            }
        }
        
        sign = [NSString stringWithFormat:@"%@&Kanwf574",sign];
        
        NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
        
        NSString *signString = [[MyMD5 md5:sign] lowercaseString];
        [params setObject:signString forKey:@"sign"];
        [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
            
           dispatch_group_leave(group);
            if (responseObject) {
                NSNumber *code = responseObject[@"code"];
                if (code.integerValue == 0) {
                    NSNumber *index = responseObject[@"result"][@"currentDayofWeek"];
                    self.weekIndex =index.integerValue - 1;
                    self.dateArray = [[NSMutableArray alloc]initWithArray:responseObject[@"result"][@"dateTaskStatus"]];
                    self.dataArray = [[NSMutableArray alloc]initWithArray:responseObject[@"result"][@"taskstatus"]];
                    

                }
            }
            
            
            
        }];
    });
    //2个网络请求结束后,刷新UI
    dispatch_group_notify(group, searialQueue, ^{
        dispatch_async(dispatch_get_global_queue(0, 0), ^{
            dispatch_async(dispatch_get_main_queue(), ^{
               
                
                
                
                [self.collectionView reloadData];
                [self.tableView reloadData];
                
               
                
                if (self.dateArray.count == 7) {
                    NSDictionary *dic = self.dateArray[self.weekIndex];
                    NSNumber *status = dic[@"status"];
                    if (status.integerValue == 302) {
                        [self setSignBtnInterace:NO];
                    }else if(status.integerValue == 303){
                        [self setSignBtnInterace:YES];
                    }
                }
                
                
                
                NSDictionary *dic = [getPeopleID totalCoins];
                NSNumber *num = dic[@"totalScore"];
                
                
                //刷新UI
                WeakSelf
                [SignInSuccessView showSuccessViewWithTitle:@"签到成功" message:@"偷偷告诉你，满签奖励多多" num:str block:^(BOOL hidden) {
                    if (hidden) {
                        [weakSelf.lb_coinsNum countFrom:self.lb_coinsNum.text.integerValue  to:num.integerValue];
                        weakSelf.lb_todayCoinsNumber.text = [NSString stringWithFormat:@"%@",[dic[@"todaySore"] stringValue]];
                    }
                }];
                
            });
        });
    });
    
}

//领取奖励
- (void)loadHttp2Data:(NSString *)str
{
    dispatch_group_t group = dispatch_group_create();
    
    dispatch_queue_t searialQueue = dispatch_queue_create("com.hmc2.www", DISPATCH_QUEUE_SERIAL);
    
    dispatch_group_enter(group);
    dispatch_group_async(group, searialQueue, ^{
        //网络请求1
        if ([getPeopleID PeopleID] && [getPeopleID PeopleIphoneNmber])
        {
            NSDictionary *params = @{
                                     @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                                     @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY]
                                     };
            NSString *url =[NSString stringWithFormat:@"%@score/getpersonintegrals",CoinsBaseUrl];
            [BaseNetManager POST2:url parameters:params completionHandler:^(id responseObj, NSError *error) {
                dispatch_group_leave(group);
                if (responseObj) {
                    NSString *code = [responseObj[@"code"] stringValue];
                    if ([code isEqualToString:@"0"]) {
                        [getPeopleID getTotalCoins:responseObj[@"result"]];
                        
                    }
                }
                
            }];
        }
    });
    dispatch_group_enter(group);
    dispatch_group_async(group, searialQueue, ^{
        //网络请求2
        NSString *url = [NSString stringWithFormat:@"%@/score/getuserTaskStatus",CoinsBaseUrl];
        
        NSDictionary *dic = @{
                              @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                              @"telephone":[EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                              @"fromModel":@"2"
                              };
        
        
        NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
            
            NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
            
            return [obj1 compare:obj2]; //升序
            
        }];
        NSString *sign = nil;
        for (int i = 0; i < result.count; i++) {
            NSString *key = result[i];
            if (i==0) {
                sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
            }else{
                
                sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
            }
        }
        
        sign = [NSString stringWithFormat:@"%@&Kanwf574",sign];
        
        NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
        
        NSString *signString = [[MyMD5 md5:sign] lowercaseString];
        [params setObject:signString forKey:@"sign"];
        [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
            
            dispatch_group_leave(group);
            if (responseObject) {
                NSNumber *code = responseObject[@"code"];
                if (code.integerValue == 0) {
                    NSNumber *index = responseObject[@"result"][@"currentDayofWeek"];
                    self.weekIndex =index.integerValue - 1;
                    self.dateArray = [[NSMutableArray alloc]initWithArray:responseObject[@"result"][@"dateTaskStatus"]];
                    self.dataArray = [[NSMutableArray alloc]initWithArray:responseObject[@"result"][@"taskstatus"]];
                    
                    
                }
            }
            
            
            
        }];
    });
    //2个网络请求结束后,刷新UI
    dispatch_group_notify(group, searialQueue, ^{
        dispatch_async(dispatch_get_global_queue(0, 0), ^{
            dispatch_async(dispatch_get_main_queue(), ^{
                
                
                
                
                [self.collectionView reloadData];
                [self.tableView reloadData];
                
                
                
                if (self.dateArray.count == 7) {
                    NSDictionary *dic = self.dateArray[self.weekIndex];
                    NSNumber *status = dic[@"status"];
                    if (status.integerValue == 302) {
                        [self setSignBtnInterace:NO];
                    }else if(status.integerValue == 303){
                        [self setSignBtnInterace:YES];
                    }
                }
                
                
                
                NSDictionary *dic = [getPeopleID totalCoins];
                NSNumber *num = dic[@"totalScore"];
                
                
                //刷新UI
                WeakSelf
                [SignInSuccessView showSuccessViewWithTitle:@"任务完成" message:@"看新闻也可以赚金币啦!!" num:str block:^(BOOL hidden) {
                    if (hidden) {
                        [weakSelf.lb_coinsNum countFrom:self.lb_coinsNum.text.integerValue  to:num.integerValue];
                        weakSelf.lb_todayCoinsNumber.text = [NSString stringWithFormat:@"%@",[dic[@"todaySore"] stringValue]];
                    }
                }];
                
            });
        });
    });
}


#pragma mark - UITableViewDataSource
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    CoinCenterTableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    cell.selectionStyle =  UITableViewCellSelectionStyleNone;
    
    [cell.btn_right addTarget:self action:@selector(btn_Click:) forControlEvents:UIControlEventTouchUpInside];
    
    cell.btn_right.tag = indexPath.row + 200;
    
    [cell refreshUIWithDic:self.dataArray[indexPath.row] index:indexPath.row];
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 67 * WIDTHRADIU + 0.5;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    
}


#pragma mark - UICollectionViewDataSource
- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return self.dateArray.count;
}
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    return 1;
}
//这是正确的方法
-(UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath{
    SignInCollectionViewCell * cell  = [collectionView dequeueReusableCellWithReuseIdentifier:@"cell" forIndexPath:indexPath];
    [cell refreshUIWithData:self.dateArray[indexPath.section] index:indexPath.section];

    return cell;
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    return CGSizeMake(33 * WIDTHRADIU, 49 * WIDTHRADIU);
}
- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section{
    
    return UIEdgeInsetsMake(0, 0, 0, 0);
}

/**
 分区内cell之间的最小行间距
 */
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section{
    
    return 0.0;
}
/**
 分区内cell之间的最小列间距
 */
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section{
    
    return 0.0;
}


- (UICollectionReusableView *)collectionView:(UICollectionView *)collectionView viewForSupplementaryElementOfKind:(NSString *)kind atIndexPath:(NSIndexPath *)indexPath {
    
    if (indexPath.item != (self.dateArray.count - 1) ) {
        LineCollectionReusableView *lineView = [collectionView dequeueReusableSupplementaryViewOfKind:UICollectionElementKindSectionFooter withReuseIdentifier:@"lineCell" forIndexPath:indexPath];
        lineView.backgroundColor = [UIColor whiteColor];
        return lineView;
    }
   
    return nil;
}
- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout referenceSizeForFooterInSection:(NSInteger)section {
    if (section == (self.dateArray.count - 1)) {
        return CGSizeZero;
    }
    
    CGFloat width = (ScreenWidth - (self.dateArray.count * 33 * WIDTHRADIU) - 40 * WIDTHRADIU)/(self.dateArray.count - 1);
    return CGSizeMake( width > 0 ? width : 17.5 * WIDTHRADIU , 49 * WIDTHRADIU);
}


- (void)exchangeMoneyClick:(UIButton *)sender{
    //[SignInSuccessView showSuccessViewWithTitle:@"+30"];
    //[RetroactiveView showSuccessView];
   // [RedPackageSuccessView showSuccessViewWithType:RedPackageTypeNoMultiple];
    
   
    
    WebVC *webVC = [[WebVC alloc]init];
    webVC.title = @"今日抽奖";
    //外网http://nginx.weface.com.cn/lesson/award/src/award.html
    //内网@"http://172.16.10.121/award/src/award.html"
    webVC.url = @"http://nginx.weface.com.cn/lesson/award/src/award.html";
    //webVC.url = @"http://172.16.10.121/award/src/award.html";
    [self.navigationController pushViewController:webVC animated:YES];
}

- (void)signBtnClick:(UIButton *)sender
{
    sender.userInteractionEnabled = NO;
    
    
    NSString *url = [NSString stringWithFormat:@"%@/score/increateScore",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone":[EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"scoreType":@"1004",
                        @"reqTimesTamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          
                          @"fromModel":@"2"
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&Kanwf574",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    WeakSelf
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            if (code.integerValue == 1006) {
                
                
                [weakSelf loadHttpData:[NSString stringWithFormat:@"%@",responseObject[@"result"][@"score"]]];
                return ;
                
            }
        }
        
        
    }];
}


- (void)btn_Click:(UIButton *)sender
{
    if ([sender.titleLabel.text isEqualToString:@"已完成"]) {
        return;
    }
    
    if (sender.tag == 200) {
        if ([sender.titleLabel.text isEqualToString:@"去关注"]) {
            [self showPopAnimation];
        }
        
    }else if (sender.tag == 201){
        if ([self isUserNotificationEnable]) {
            [self increase2ScoreWithType:@"1006"];
        }else {
            [self goToAppSystemSetting];
        }
    }
}

- (void)increaseScoreWithType:(NSString *)type
{
    NSString *url = [NSString stringWithFormat:@"%@/score/increateScore",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone":[EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"scoreType":type,
                          @"reqTimesTamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          
                          @"fromModel":@"2"
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&Kanwf574",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    WeakSelf
   
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            if (code.integerValue == 1006) {
                
                if ([type isEqualToString:@""]) {
                    
                }
                  [[NSUserDefaults standardUserDefaults]setObject:@"openedPush" forKey:@"pushKey"];
                [[NSUserDefaults standardUserDefaults]synchronize];
                
                [weakSelf loadData];
                
                return ;
                
            }
        }
       
        
    }];
}

//领取的时候需要弹框
- (void)increase2ScoreWithType:(NSString *)type
{
    NSString *url = [NSString stringWithFormat:@"%@/score/increateScore",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone":[EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"scoreType":type,
                          @"reqTimesTamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          
                          @"fromModel":@"2"
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&Kanwf574",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    WeakSelf
    
    [CTAPIBaseManager POST:url params:params completionHandler:^(id  _Nonnull responseObject, NSError * _Nonnull error) {
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            if (code.integerValue == 1006) {
                
                if ([type isEqualToString:@""]) {
                    
                }
                [weakSelf loadHttpData:[NSString stringWithFormat:@"%@",responseObject[@"result"][@"score"]]];
                return ;
                
            }
        }
        
        
    }];
}




- (void)goToCoinsDetailVC:(UIButton *)sender
{
   
    CoinsDetailListVC *vc = [[CoinsDetailListVC alloc]init];
    vc.title = @"金币明细";
    vc.type = ListVCTypeCoinsDetail;
    vc.hidesBottomBarWhenPushed = YES;
    [self.navigationController pushViewController:vc animated:YES];
}


#pragma mark - private methods
-(NSInteger )getNowTimeTimestamp3{
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init] ;
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss SSS"]; // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    //设置时区,这个对于时间的处理有时很重要
    
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Beijing"];
    
    [formatter setTimeZone:timeZone];
    
    NSDate *datenow = [NSDate date];//现在时间,你可以输出来看下是什么格式
    
    NSInteger timeSp = [datenow timeIntervalSince1970]*1000;
    
    return timeSp;
}

//计算今天周几
- (NSInteger)getNowWeekday {
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierGregorian];
    NSDateComponents *comps = [[NSDateComponents alloc] init];
    NSInteger unitFlags = NSCalendarUnitYear | NSCalendarUnitMonth | NSCalendarUnitDay | NSCalendarUnitWeekday |
    NSCalendarUnitHour | NSCalendarUnitMinute | NSCalendarUnitSecond;
    NSDate *now = [NSDate date];
    // 话说在真机上需要设置区域，才能正确获取本地日期，天朝代码:zh_CN
    calendar.locale = [[NSLocale alloc] initWithLocaleIdentifier:@"zh_CN"];
    comps = [calendar components:unitFlags fromDate:now];
    return [comps weekday]  - 1;
}

- (BOOL)isUserNotificationEnable { // 判断用户是否允许接收通知
    BOOL isEnable = NO;
    if ([[UIDevice currentDevice].systemVersion floatValue] >= 8.0f) { // iOS版本 >=8.0 处理逻辑
        UIUserNotificationSettings *setting = [[UIApplication sharedApplication] currentUserNotificationSettings];
        isEnable = (UIUserNotificationTypeNone == setting.types) ? NO : YES;
    } else { // iOS版本 <8.0 处理逻辑
        UIRemoteNotificationType type = [[UIApplication sharedApplication] enabledRemoteNotificationTypes];
        isEnable = (UIRemoteNotificationTypeNone == type) ? NO : YES;
    }
    return isEnable;
}


#pragma mark - 跳转
// 如果用户关闭了接收通知功能，该方法可以跳转到APP设置页面进行修改  iOS版本 >=8.0 处理逻辑
- (void)goToAppSystemSetting {
    WeakSelf
    UIApplication *application = [UIApplication sharedApplication];
    NSURL *url = [NSURL URLWithString:UIApplicationOpenSettingsURLString];
    if ([application canOpenURL:url]) {
        if ([application respondsToSelector:@selector(openURL:options:completionHandler:)]) {
            [application openURL:url options:@{} completionHandler:^(BOOL success) {
                     [weakSelf increaseScoreWithType:@"1006"];
            }];
        } else {
            [application openURL:url];
             [self increaseScoreWithType:@"1006"];
        }
    }
}


//跳转微信
-(void)openWechat{
    NSURL * url = [NSURL URLWithString:@"weixin://"];
    BOOL canOpen = [[UIApplication sharedApplication] canOpenURL:url];
    //先判断是否能打开该url
    if (canOpen)
    {   //打开微信
        WeakSelf
        dispatch_time_t popTime = dispatch_time(DISPATCH_TIME_NOW, 0.5 * NSEC_PER_SEC);
        dispatch_after(popTime, dispatch_get_main_queue(), ^(void){
            [[UIApplication sharedApplication] openURL:url options:@{} completionHandler:^(BOOL success) {
                [weakSelf increaseScoreWithType:@"1005"];
            }];
        });
        
        
    }else {
        [SVProgressHUD showInfoWithStatus:@"您的设备未安装微信APP"];
    }
}



#pragma mark 显示弹框
- (void)showPopAnimation
{
    ZJAnimationPopStyle popStyle = ZJAnimationPopStyleShakeFromTop;
    ZJAnimationDismissStyle dismissStyle = ZJAnimationDismissStyleNO;
    
    
    OfficialAccountsAlertView *alertView = [[OfficialAccountsAlertView alloc]initWithFrame:CGRectMake(0, 0, 280 * WIDTHRADIU, 225 * WIDTHRADIU)];
    alertView.backgroundColor = [UIColor whiteColor];
    alertView.layer.cornerRadius = 15 * WIDTHRADIU;
    _customView = alertView;
    // 1.初始化
    ZJAnimationPopView *popView = [[ZJAnimationPopView alloc] initWithCustomView:alertView popStyle:popStyle dismissStyle:dismissStyle];
    
    // 2.设置属性，可不设置使用默认值，见注解
    // 2.1 显示时点击背景是否移除弹框
    popView.isClickBGDismiss = ![OfficialAccountsAlertView isKindOfClass:[OfficialAccountsAlertView class]];
    // 2.2 显示时背景的透明度
    popView.popBGAlpha = 0.5f;
    // 2.3 显示时是否监听屏幕旋转
    popView.isObserverOrientationChange = NO;
    // 2.4 显示时动画时长
    //    popView.popAnimationDuration = 0.8f;
    // 2.5 移除时动画时长
    //    popView.dismissAnimationDuration = 0.8f;
    
    // 2.6 显示完成回调
    popView.popComplete = ^{
        NSLog(@"显示完成");
    };
    // 2.7 移除完成回调
    popView.dismissComplete = ^{
        NSLog(@"移除完成");
    };
    
    // 3.处理自定义视图操作事件
    [self handleCustomActionEnvent:popView];
    
    // 4.显示弹框
    [popView pop];
}

#pragma mark 处理自定义视图操作事件
- (void)handleCustomActionEnvent:(ZJAnimationPopView *)popView
{
    // 在监听自定义视图的block操作事件时，要使用弱对象来避免循环引用
    __weak typeof(popView) weakPopView = popView;
    if ([_customView isKindOfClass:[OfficialAccountsAlertView class]]) {
        OfficialAccountsAlertView *infoPopView = _customView;
        infoPopView.block = ^(BOOL click) {
            if (click) {
                [weakPopView dismiss];
                
                [self.view makeToast:@"复制成功"];
                UIPasteboard *pasteboard = [UIPasteboard generalPasteboard];
                pasteboard.string = @"看看社保";
                
                
                [self openWechat];
            }
        };
    }
}


#pragma mark - getters and setters

- (UIButton *)rightBtn
{
    if (!_rightBtn) {
        _rightBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _rightBtn.frame = CGRectMake(0, 0, 65, 22);
        [_rightBtn setTitle:@"明细" forState:UIControlStateNormal];
        [_rightBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [_rightBtn setImage:[UIImage imageNamed:@"btn_coinsdetail"] forState:UIControlStateNormal];
        _rightBtn.titleLabel.font = [UIFont systemFontOfSize:14 * WIDTHRADIU];
        [_rightBtn layoutButtonWithEdgeInsetsStyle:GLButtonEdgeInsetsStyleLeft imageTitleSpace:4 * WIDTHRADIU ];
        _rightBtn.backgroundColor = [UIColor colorWithHex:0xfa6b05];
        _rightBtn.layer.cornerRadius = 11;
        [_rightBtn addTarget:self action:@selector(goToCoinsDetailVC:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _rightBtn;
}

- (UIView *)headerView
{
    if (!_headerView) {
        _headerView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, 288 * WIDTHRADIU)];
        _headerView.backgroundColor = [UIColor whiteColor];
        
        [_headerView addSubview:self.cardView];
        [_headerView addSubview:self.collectionView];
        [_headerView addSubview:self.btn_signIn];
    }
    return _headerView;
}

- (UIView *)cardView
{
    if (!_cardView) {
        _cardView = [[UIView alloc]initWithFrame:CGRectMake(10 * WIDTHRADIU, 10 * WIDTHRADIU, ScreenWidth - 20 * WIDTHRADIU, 145 * WIDTHRADIU)];
        _cardView.layer.cornerRadius = 15 * WIDTHRADIU;
        _cardView.layer.masksToBounds = YES;
        CAGradientLayer *layer = [CAGradientLayer new];
        //colors存放渐变的颜色的数组
        layer.colors=@[(__bridge id)[UIColor colorWithHex:0xf99804].CGColor,(__bridge id)[UIColor colorWithHex:0xfcc101].CGColor];
        /**
         * 起点和终点表示的坐标系位置，(0,0)表示左上角，(1,1)表示右下角
         */
        layer.startPoint = CGPointMake(0.4, 1);
        layer.endPoint = CGPointMake(0.6, 0);
        layer.frame = _cardView.bounds;
        [_cardView.layer addSublayer:layer];
        [_cardView addSubview:self.lb_coinsNum];
        [_cardView addSubview:self.lb_coinsNumTitle];
        [_cardView addSubview:self.btn_exchangeMoney];
        [_cardView addSubview:self.lb_allCoinsNumber];
        [_cardView addSubview:self.lb_mycoin];
        [_cardView addSubview:self.divideLine];
        [_cardView addSubview:self.lb_todayCoinsNumber];
        [_cardView addSubview:self.lb_todayCoin];
        
    }
    return _cardView;
}

- (UICountingLabel *)lb_coinsNum
{
    if (!_lb_coinsNum) {
        _lb_coinsNum = [[UICountingLabel alloc]init];
        _lb_coinsNum.text = @"0";
        _lb_coinsNum.method = UILabelCountingMethodEaseOut;
        _lb_coinsNum.format = @"%d";
        _lb_coinsNum.textColor = [UIColor whiteColor];
        _lb_coinsNum.font = [UIFont systemFontOfSize:35 * WIDTHRADIU];
        _lb_coinsNum.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_coinsNum;
}

- (UILabel *)lb_coinsNumTitle
{
    if (!_lb_coinsNumTitle) {
        _lb_coinsNumTitle = [[UILabel alloc]init];
        _lb_coinsNumTitle.text = @"可用金币(个)";
        _lb_coinsNumTitle.textColor = [UIColor whiteColor];
        _lb_coinsNumTitle.font = [UIFont systemFontOfSize:13 * WIDTHRADIU];
        _lb_coinsNumTitle.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_coinsNumTitle;
}

- (ExchangeMoneyBtn *)btn_exchangeMoney
{
    if (!_btn_exchangeMoney) {
        _btn_exchangeMoney = [ExchangeMoneyBtn buttonWithType:UIButtonTypeCustom];
        [_btn_exchangeMoney setTitle:@"金币抽奖" forState:UIControlStateNormal];
        [_btn_exchangeMoney setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _btn_exchangeMoney.titleLabel.font = [UIFont systemFontOfSize:13 * WIDTHRADIU];
        _btn_exchangeMoney.backgroundColor = [UIColor colorWithHex:0xfa6b05];
        [_btn_exchangeMoney addTarget:self action:@selector(exchangeMoneyClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _btn_exchangeMoney;
}

- (UILabel *)lb_allCoinsNumber
{
    if (!_lb_allCoinsNumber) {
        _lb_allCoinsNumber = [[UILabel alloc]init];
        _lb_allCoinsNumber.text = @"--";
        _lb_allCoinsNumber.font = [UIFont systemFontOfSize:20 * WIDTHRADIU];
        _lb_allCoinsNumber.textColor = [UIColor colorWithHex:0Xfee2b8];
        _lb_allCoinsNumber.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_allCoinsNumber;
}

- (UILabel *)lb_mycoin
{
    if (!_lb_mycoin) {
        _lb_mycoin = [[UILabel alloc]init];
        _lb_mycoin.text = @"累计金币(个)";
        _lb_mycoin.textColor = [UIColor colorWithHex:0Xfee2b8];
        _lb_mycoin.font = [UIFont systemFontOfSize:13*WIDTHRADIU];
        _lb_mycoin.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_mycoin;
}

- (UIView *)divideLine
{
    if (!_divideLine) {
        _divideLine = [[UIView alloc]init];
        _divideLine.backgroundColor = [UIColor colorWithHex:0xfee2b8];
    }
    return _divideLine;
}

- (UILabel *)lb_todayCoinsNumber
{
    if (!_lb_todayCoinsNumber) {
        _lb_todayCoinsNumber = [[UILabel alloc]init];
        _lb_todayCoinsNumber.text = @"0";
        _lb_todayCoinsNumber.font = [UIFont systemFontOfSize:20 * WIDTHRADIU];
        _lb_todayCoinsNumber.textColor = [UIColor colorWithHex:0xfee2b8];
        _lb_todayCoinsNumber.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_todayCoinsNumber;
}

- (UILabel *)lb_todayCoin
{
    if (!_lb_todayCoin) {
        _lb_todayCoin = [[UILabel alloc]init];
        _lb_todayCoin.text = @"今日金币";
        _lb_todayCoin.textColor = [UIColor colorWithHex:0xfee2b8];
        _lb_todayCoin.font = [UIFont systemFontOfSize:13*WIDTHRADIU];
        _lb_todayCoin.textAlignment = NSTextAlignmentCenter;
    }
    return _lb_todayCoin;
}


- (UICollectionView *)collectionView
{
    if (!_collectionView) {
        //创建一个layout布局类
        UICollectionViewFlowLayout * layout = [[UICollectionViewFlowLayout alloc]init];
        //设置布局方向为垂直流布局
        layout.scrollDirection = UICollectionViewScrollDirectionHorizontal;
        //设置每个item的大小为100*100
        layout.itemSize = CGSizeMake(100, 60);

        _collectionView = [[UICollectionView alloc]initWithFrame:CGRectMake(20 * WIDTHRADIU, 170 * WIDTHRADIU, ScreenWidth - 40 * WIDTHRADIU, 49 * WIDTHRADIU) collectionViewLayout:layout];
        _collectionView.backgroundColor = [UIColor whiteColor];
        _collectionView.delegate = self;
        _collectionView.dataSource = self;
        [_collectionView registerClass:[SignInCollectionViewCell class] forCellWithReuseIdentifier:@"cell"];
        [_collectionView registerClass:[LineCollectionReusableView class] forSupplementaryViewOfKind:UICollectionElementKindSectionFooter withReuseIdentifier:@"lineCell"];
    }
    return _collectionView;
}

- (UIButton *)btn_signIn
{
    if (!_btn_signIn) {
        _btn_signIn = [UIButton buttonWithType:UIButtonTypeCustom];
        _btn_signIn.frame = CGRectMake(10 * WIDTHRADIU, CGRectGetMaxY(self.collectionView.frame) + 15 * WIDTHRADIU, ScreenWidth - 20 * WIDTHRADIU, 45 * WIDTHRADIU);
        [_btn_signIn setTitle:@"签到" forState:UIControlStateNormal];
        [_btn_signIn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        _btn_signIn.titleLabel.font = [UIFont systemFontOfSize:17 * WIDTHRADIU];
        _btn_signIn.backgroundColor = [UIColor colorWithHex:0xed8b0b];
        _btn_signIn.layer.cornerRadius = 22 * WIDTHRADIU;
        _btn_signIn.userInteractionEnabled = YES;
        [_btn_signIn addTarget:self action:@selector(signBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    }
    return _btn_signIn;
}


- (UITableView *)tableView
{
    if (!_tableView) {
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 0, ScreenWidth, ScreenHeight - cl_kNavigationBarHeight)];
        _tableView.showsHorizontalScrollIndicator = NO;
        _tableView.showsVerticalScrollIndicator = NO;
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.tableHeaderView = self.headerView;
        [_tableView registerClass:[CoinCenterTableViewCell class] forCellReuseIdentifier:@"cell"];
        _tableView.separatorStyle =  UITableViewCellSeparatorStyleNone;
        
        _tableView.hidden = YES;
        
        
    }
    return _tableView;
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
